<?php
/*
Plugin Name: WP Stop Profanity
Plugin URI: http://www.countingrows.com/wp-stop-profanity/
Description: Stops Profanity on your site by allowing you to select the words that you want blacked out.
Version: 0.3
Author: Matthew Price
Author URI: http://www.countingrows.com/
License: GPL2
*/

if($_GET['action']); {

	switch ($_GET['action']) {
		
	case 'update-options': wp_profanity_update_options(); break;

	}
}	
function wp_stop_profanity_get_words() {
	$count = count($words);
	$i = 1;
	foreach ($words as $word) {
		$content .= "'" . $word . "', ";
	}
	return $content;
}		

/* 	Filter Words on "the_content();" */
function wp_stop_profanity_the_content() {
if (is_admin()) { } else {	
	$the_content = get_the_content();
	$words = unserialize(get_option('wp_profanity_words'));
	$findWords = array($words);
		foreach ($findWords as $find) {
		$replace = '';
			for ($i=1; $i<= strlen($find); $i++) {
			$replace = '<span style="padding: 0 3px 0 3px;background: #000000; color: #FFFFFF;">&bull;&bull;&bull;&bull;</span>';
			}
		}	
	$new_content = str_replace($find,$replace,$the_content);
	return $new_content;
	}
}

add_filter('the_content', 'wp_stop_profanity_the_content');

/* 	Filter Words on "comment_text();" */
function wp_stop_profanity_the_comments() {	
if (is_admin()) { } else {
	$comments = get_comment_text(); 
	$words = unserialize(get_option('wp_profanity_words'));
	$findWords = array($words);
		foreach ($findWords as $find) {
		$replace = '';
			for ($i=1; $i<= strlen($find); $i++) {
			$replace = '<span style="padding: 0 3px 0 3px;background: #000000; color: #FFFFFF;">&bull;&bull;&bull;&bull;</span>';
			}
		}	
	$new_content = str_replace($find,$replace,$comments);
	return $new_content;
	}
}

add_filter('comment_text', 'wp_stop_profanity_the_comments');

/* 	Filter Words on "the_title();" */
function wp_stop_profanity_the_title($content) {	
if (is_admin()) { return $content; } else {
	$the_title = $content; 
	$words = unserialize(get_option('wp_profanity_words'));
	$findWords = array($words);
		foreach ($findWords as $find) {
		$replace = '';
			for ($i=1; $i<= strlen($find); $i++) {
			$replace = '<span style="padding: 0 3px 0 3px;background: #000000; color: #FFFFFF;">&bull;&bull;&bull;&bull;</span>';
			}
		}	
	$new_content = str_replace($find,$replace,$the_title);
	return $new_content;
	}
}

add_filter( 'the_title', 'wp_stop_profanity_the_title', 1);

function wp_stop_profanity_options() {
?>
<div class="wrap">
<h2>WP Stop Profanity Options</h2>

<?php if ($_GET['options'] == 'updated') { ?>
<div id="message" class="updated below-h2">WP Stop Profanity Options Updated</div>
<?php } ?>

<form method="post" action="?action=update-options" id="profanityWords">
<div class="formItem">
Please type your words in the box below.  use a comma to separate.<br><br>
For example:  word,word,word<br><br>
</div>
<div class="formItem">
<label for="words">Unacceptable Words</label>
<textarea name="words" id="words" class="textInput">
<?php
if (get_option('wp_profanity_words')) {
$words = unserialize(get_option('wp_profanity_words'));
$count = count($words);
$i = 1;
foreach ($words as $word) {
	if ($count == $i) {
	echo $word;
	} else { 
	echo $word . ",";
	}
	$i++;
	}
}	
?>
</textarea>
</div>
<div class="formItem">
<input type="submit" name="submit" id="submit" value="Submit" class="button">
</div>
</form>

</div>
<?
}

function wp_profanity_update_options() {

$words = $_POST['words'];
$words = explode(',', $words);
$words = serialize($words);

$value = $words;

$option_name = 'wp_profanity_words' ; 
  if ( get_option($option_name)  != $value) {
    update_option($option_name, $value);
  } else {
    $deprecated=' ';
    $autoload='no';
    add_option($option_name, $value, $deprecated, $autoload);
  }
	header("Location: " . $_SERVER['PHP_SELF'] . "?page=wp-stop-profanity&options=updated");

}


function wp_profanity_menu() {
add_management_page(__('WP Stop Profanity','wp stop profanity'), __('WP Stop Profanity','wp stop profanity'), 'manage_options', 'wp-stop-profanity', 'wp_stop_profanity_options', '', '4');
}

function wp_stop_profanity_styles() {
?>
<style type="text/css">
#profanityWords .formItem {margin-bottom: 10px; clear: both;}
#profanityWords .formItem label {float: left; width: 150px;}
#profanityWords .formItem .textInput {width: 600px; height: 200px;}
</style>
<?
}
add_action( 'wp_head', 'wp_stop_profanity_styles' );
add_action( 'admin_menu', 'wp_profanity_menu' );

?>